import java.util.Deque;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;

/**
 * Created by Ju on 12/1/15.
 *
 * AdHoc di15b
 *
 * Ein Buch hat einen Autor, einen Titel, und ein Erscheinungsjahr.
 *
 * * erstellen Sie eine Klasse Book mit passenden Objektvariablen. 25%
 *
 * für die folgenden Methoden erstellen Sie Aufrufe in main(), die diese
 * Methoden aufrufen und sinnvoll testen.
 *
 * * Erstellen Sie einen Konstruktor für die Klasse, mit Autor, titel,
 *  und Erscheinungsjahr als Parameter. 25%
 *
 * * Erstellen Sie eine nicht-statische Methode print() für die Klasse, die
 * Autor, Titel, und Erscheinungsjahr eines Buches ausgibt. 25%
 *
 * * Erstellen Sie eine statische Methode print_books(), die eine queue
 * oder deque von Book-Objekten als Parameter nimmt und ausdruckt. 25%
 *
 * Nachdem Sie die obigen Aufgaben abgegeben haben, verwenden Sie den
 * Rest der Zeit für folgende Aufgaben (bei Schwierigkeiten fragen Sie
 * die tutoren oder Übungsleiter):
 *
 * * Erstellen Sie eine Methode author_books(), die einen Autor und eine
 * queue oder deque von Book-Objekten als Parameter nimmt und die
 * Bücher mit dem übergebenene Autor ausdruckt (und die anderen nicht).
 * Sie können Strings s1 und s2 mit se.equals(s2) vergleichen.
 *
 * * Erstellen Sie eine Methode title_book, die einen Titel und eine#
 * queue oder deque von Book-Objekten als Parameter nimmt und *ein*
 * Buch mit dem übergebenen Titel ausdruckt (oder keines, wenn kein
 * Buch mit dem Titel in der queue/deque ist).
 *
 * * Verwenden Sie eine Map anstatt der queue/deque, mit dem Titel als
 * key, und implementieren Sie title_book() dafür. Welche
 * Einschränkungen gibt es jetzt im Vergleich zu vorher. Ist diese
 * Verwendung von Map sinnvoll? Wäre es sinnvoll, den Autor als key zu
 * verwenden? Warum bzw. warum nicht?
 *
 */

public class Book {
    private String author;
    private String title;
    private int year;

    public Book(String author, String title, int year) {
        this.author = author;
        this.title = title;
        this.year = year;
    }

    public void print() {
        System.out.println("Autor: " + this.author);
        System.out.println("Titel: " + this.title);
        System.out.println("Jahr:  " + this.year);
    }

    public static void print_books(Deque<Book> books) {
        while (!books.isEmpty())
            books.poll().print();
    }


    /* Zusatz */

    public static void author_books(String author, Deque<Book> books) {
        while (!books.isEmpty()) {
            Book temp = books.poll();
            if (temp.author.equals(author)) temp.print();
        }
    }

    public static void title_books(String title, Deque<Book> books) {
        while (!books.isEmpty()) {
            Book temp = books.poll();
            if (temp.title.equals(title)) {
                temp.print();
                break;
            }
        }
    }

    public static void title_books(String title, Map<String, Book> books) {
        books.get(title).print();
    }


    /* helper-Methode, gibt eine queue mit ausgewählten büchern aus */
    private static Deque<Book> helper() {
        Book book1 = new Book("Orwell, George", "1984", 1000);
        Book book2 = new Book("Orwell, George", "Animal Farm", 1000);
        Book book3 = new Book("Doctorow, Cory", "Little brother", 1000);
        Book book4 = new Book("Doctorow, Cory", "Little brother", 1000);

        Deque<Book> books = new LinkedList<>();

        books.offer(book1);
        books.offer(book2);
        books.offer(book3);
        books.offer(book4);

        return books;
    }

    public static void main(String[] args) {
        String xxx = "\n<>-<>-<>-<>-<>-<>-<>-<>-<>-<>-<>-<>-<>-<>-<>-<>-<>-<>-<>-<>-<>-<>-<>";
        System.out.println("Test print_books(Deque<Book> books):" + xxx);
        print_books(helper());


        System.out.println("\nTest author_books():" + xxx);
        author_books("Orwell, George", helper());


        System.out.println("\nTest title_books(String title, Deque<Book> books):" + xxx);
        title_books("Little brother", helper());


        System.out.println("\nTest title_books(String title, Map<String, Book> books):" + xxx);
        Map<String, Book> map = new HashMap<>();
        Deque<Book> books = helper();
        map.put("1984", books.poll());
        map.put("Animal Farm", books.poll());
        map.put("Little brother", books.poll());
        // folgendes ist überflüssig, da Keys einmalig sind -> eintrag mit "Little brother" würde überschrieben werden
        // map.put("Little brother", books.poll());

        title_books("1984", map);
    }
}